# primer.sql was originally generated by the autoSql program, which also 
# generated primer.c and primer.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Information about a PCR or sequencing primer
CREATE TABLE primer (
    name varchar(64) not null,	# Primer name
    element varchar(64) not null,	# Region primer amplifies/sequences
    seq varchar(64) not null,	# DNA sequence
    plate varchar(64) not null,	# Plate stored in
    row char(1) not null,	# Row stored in
    col tinyint not null,	# Column stored in
    project varchar(255) not null,	# Project this used for
    purpose varchar(255) not null,	# PCR, sequencing, etc.
    productSize int not null,	# Size of PCR product
              #Indices
    PRIMARY KEY(name),
    INDEX(element),
    INDEX(seq),
    INDEX (plate)
);
